import HeadingIdGenerator from "./heading-id-generator";
export interface HeadingData {
    content: string;
    level: number;
    id: string;
}
export interface TransformMarkdownOutput {
    /**
     * An array of slide configs.
     */
    slideConfigs: object[];
    /**
     * whehter we found [TOC] in markdown file or not.
     */
    tocBracketEnabled: boolean;
    /**
     * An array of headings data
     */
    headings: HeadingData[];
    /**
     * Get `---\n...\n---\n` string.
     */
    frontMatterString: string;
    /**
     * Transformed markdown string
     */
    outputString: string;
}
export interface TransformMarkdownOptions {
    forPreview: boolean;
    headingIdGenerator?: HeadingIdGenerator;
    forMarkdownExport?: boolean;
    usePandocParser?: boolean;
}
export declare function transformMarkdown(inputString: string, { forPreview, headingIdGenerator, forMarkdownExport, usePandocParser, }: TransformMarkdownOptions): TransformMarkdownOutput;
