// Modified from github.com/shd101wyy/mume
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};

(function (mod){ //[HyperMD] UMD patched!
  /*commonjs*/  ("object"==typeof exports&&"undefined"!=typeof module) ? mod(null, exports, require("../addon/fold"), require("./heading-id-generator"), require("./custom-subjects")) :
  /*amd*/       ("function"==typeof define&&define.amd) ? define(["require","exports","../addon/fold","./heading-id-generator","./custom-subjects"], mod) :
  /*plain env*/ mod(null, (this.HyperMD.PreviewTransform = this.HyperMD.PreviewTransform || {}), HyperMD.Fold, HyperMD.PreviewHeadingIDGenerator, HyperMD.PreviewCustomSubjects);
})(function (require, exports, fold_1, heading_id_generator_1, custom_subjects_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    heading_id_generator_1 = __importDefault(heading_id_generator_1);
    function createAnchor(lineNo) {
        return "\n\n<p data-line=\"" + lineNo + "\" class=\"sync-line\" style=\"margin:0;\"></p>\n\n";
    }
    var fileExtensionToLanguageMap = {
        vhd: "vhdl",
        erl: "erlang",
        dot: "dot",
        gv: "dot",
        viz: "dot",
    };
    var selfClosingTag = {
        area: 1,
        base: 1,
        br: 1,
        col: 1,
        command: 1,
        embed: 1,
        hr: 1,
        img: 1,
        input: 1,
        keygen: 1,
        link: 1,
        meta: 1,
        param: 1,
        source: 1,
        track: 1,
        wbr: 1,
    };
    function transformMarkdown(inputString, _a) {
        var _b = _a.forPreview, forPreview = _b === void 0 ? false : _b, _c = _a.headingIdGenerator, headingIdGenerator = _c === void 0 ? new heading_id_generator_1.default() : _c, _d = _a.forMarkdownExport, forMarkdownExport = _d === void 0 ? false : _d, _e = _a.usePandocParser, usePandocParser = _e === void 0 ? false : _e;
        var lastOpeningCodeBlockFence = null;
        var codeChunkOffset = 0;
        var slideConfigs = [];
        var headings = [];
        var tocBracketEnabled = false;
        var frontMatterString = "";
        function helper(i, lineNo) {
            if (lineNo === void 0) { lineNo = 0; }
            var outputString = "";
            while (i < inputString.length) {
                if (inputString[i] === "\n") {
                    // return helper(i+1, lineNo+1, outputString+'\n')
                    i = i + 1;
                    lineNo = lineNo + 1;
                    outputString = outputString + "\n";
                    continue;
                }
                var end = inputString.indexOf("\n", i);
                if (end < 0) {
                    end = inputString.length;
                }
                var line = inputString.substring(i, end);
                var inCodeBlock = !!lastOpeningCodeBlockFence;
                var currentCodeBlockFence = (line.match(/^[`]{3,}/) || [])[0];
                if (currentCodeBlockFence) {
                    if (!inCodeBlock && forPreview) {
                        outputString += createAnchor(lineNo);
                    }
                    var containsCmd = !!line.match(/\"?cmd\"?\s*[:=\s}]/);
                    if (!inCodeBlock && containsCmd) {
                        // it's code chunk, so mark its offset
                        line = line.replace("{", "{code_chunk_offset=" + codeChunkOffset + ", ");
                        codeChunkOffset++;
                    }
                    if (!inCodeBlock) {
                        lastOpeningCodeBlockFence = currentCodeBlockFence;
                    }
                    else if (currentCodeBlockFence.length >= lastOpeningCodeBlockFence.length) {
                        lastOpeningCodeBlockFence = null;
                    }
                    // return helper(end+1, lineNo+1, outputString+line+'\n')
                    i = end + 1;
                    lineNo = lineNo + 1;
                    outputString = outputString + line + "\n";
                    continue;
                }
                if (inCodeBlock) {
                    // return helper(end+1, lineNo+1, outputString+line+'\n')
                    i = end + 1;
                    lineNo = lineNo + 1;
                    outputString = outputString + line + "\n";
                    continue;
                }
                var headingMatch = void 0;
                var taskListItemMatch = void 0;
                var htmlTagMatch = void 0;
                /*
                  // I changed this because for case like:
                  * haha
                  ![](image.png)
                  The image will not be displayed correctly in preview as there will be `anchor` inserted
                  between...
                  */
                if (line.match(/^(\!\[|@import)/) &&
                    inputString[i - 1] === "\n" &&
                    inputString[i - 2] === "\n") {
                    if (forPreview) {
                        outputString += createAnchor(lineNo); // insert anchor for scroll sync
                    }
                    /* tslint:disable-next-line:no-conditional-assignment */
                }
                else if ((headingMatch = line.match(/^(\#{1,7})\s+.*/))) {
                    /* ((headingMatch = line.match(/^(\#{1,7})(.+)$/)) ||
                              // the ==== and --- headers don't work well. For example, table and list will affect it, therefore I decide not to support it.
                              (inputString[end + 1] === '=' && inputString[end + 2] === '=') ||
                              (inputString[end + 1] === '-' && inputString[end + 2] === '-')) */ // headings
                    if (forPreview) {
                        outputString += createAnchor(lineNo);
                    }
                    var heading = void 0;
                    var level = void 0;
                    var tag = void 0;
                    heading = line.replace(headingMatch[1], "");
                    tag = headingMatch[1];
                    level = tag.length;
                    // check {class:string, id:string, ignore:boolean}
                    var optMatch = heading.match(/(\s+\{|^\{)(.+?)\}(\s*)$/);
                    var classes = "";
                    var id = "";
                    var ignore = false;
                    var opt = void 0;
                    if (optMatch) {
                        heading = heading.replace(optMatch[0], "");
                        try {
                            opt = fold_1.parseAttributes(optMatch[0]);
                            (classes = opt["class"]),
                                (id = opt["id"]),
                                (ignore = opt["ignore"]);
                            delete opt["class"];
                            delete opt["id"];
                            delete opt["ignore"];
                        }
                        catch (e) {
                            heading = "OptionsError: " + optMatch[1];
                            ignore = true;
                        }
                    }
                    if (!id) {
                        id = headingIdGenerator.generateId(heading);
                    }
                    if (!ignore) {
                        headings.push({ content: heading, level: level, id: id });
                    }
                    if (usePandocParser) {
                        // pandoc
                        var optionsStr = "{";
                        if (id) {
                            optionsStr += "#" + id + " ";
                        }
                        if (classes) {
                            optionsStr += "." + classes.replace(/\s+/g, " .") + " ";
                        }
                        if (opt) {
                            for (var key in opt) {
                                if (typeof opt[key] === "number") {
                                    optionsStr += " " + key + "=" + opt[key];
                                }
                                else {
                                    optionsStr += " " + key + '="' + opt[key] + '"';
                                }
                            }
                        }
                        optionsStr += "}";
                        // return helper(end+1, lineNo+1, outputString + `${tag} ${heading} ${optionsStr}` + '\n')
                        i = end + 1;
                        lineNo = lineNo + 1;
                        outputString =
                            outputString + (tag + " " + heading + " " + optionsStr) + "\n";
                        continue;
                    }
                    else {
                        // markdown-it
                        if (!forMarkdownExport) {
                            // convert to <h? ... ></h?>
                            line = tag + " " + heading + "\n<p class=\"mume-header " + classes + "\" id=\"" + id + "\"></p>";
                        }
                        else {
                            line = tag + " " + heading;
                        }
                        // return helper(end+1, lineNo+1, outputString + line + '\n\n')
                        i = end + 1;
                        lineNo = lineNo + 1;
                        outputString = outputString + line + "\n\n";
                        continue;
                        // I added one extra `\n` here because remarkable renders content below
                        // heading differently with `\n` and without `\n`.
                    }
                }
                else if (line.match(/^\<!--/)) {
                    // custom comment
                    if (forPreview) {
                        outputString += createAnchor(lineNo);
                    }
                    var commentEnd = inputString.indexOf("-->", i + 4);
                    if (commentEnd < 0) {
                        // didn't find -->
                        // return helper(inputString.length, lineNo+1, outputString+'\n')
                        i = inputString.length;
                        lineNo = lineNo + 1;
                        outputString = outputString + "\n";
                        continue;
                    }
                    else {
                        commentEnd += 3;
                    }
                    var subjectMatch = line.match(/^\<!--\s+([^\s]+)/);
                    if (!subjectMatch) {
                        var content = inputString.slice(i + 4, commentEnd - 3).trim();
                        var newlinesMatch = content.match(/\n/g);
                        var newlines = newlinesMatch ? newlinesMatch.length : 0;
                        // return helper(commentEnd, lineNo + newlines, outputString + '\n')
                        i = commentEnd;
                        lineNo = lineNo + newlines;
                        outputString = outputString + "\n";
                        continue;
                    }
                    else {
                        var subject = subjectMatch[1];
                        if (subject === "@import") {
                            var commentEnd2 = line.lastIndexOf("-->");
                            if (commentEnd2 > 0) {
                                line = line.slice(4, commentEnd2).trim();
                            }
                        }
                        else if (subject in custom_subjects_1.CustomSubjects) {
                            var content = inputString.slice(i + 4, commentEnd - 3).trim();
                            var newlinesMatch = content.match(/\n/g);
                            var newlines = newlinesMatch ? newlinesMatch.length : 0;
                            var optionsMatch = content.match(/^([^\s]+?)\s([\s\S]+)$/);
                            var options = {};
                            if (optionsMatch && optionsMatch[2]) {
                                options = fold_1.parseAttributes(optionsMatch[2]);
                            }
                            options["lineNo"] = lineNo;
                            if (subject === "pagebreak" || subject === "newpage") {
                                // pagebreak
                                // return helper(commentEnd, lineNo + newlines, outputString + '<div class="pagebreak"> </div>\n')
                                i = commentEnd;
                                lineNo = lineNo + newlines;
                                outputString =
                                    outputString +
                                        '<div class="pagebreak html2pdf__page-break"> </div>\n';
                                continue;
                            }
                            else if (subject.match(/^\.?slide\:?$/)) {
                                // slide
                                slideConfigs.push(options);
                                if (forMarkdownExport) {
                                    // return helper(commentEnd, lineNo + newlines, outputString + `<!-- ${content} -->` + '\n')
                                    i = commentEnd;
                                    lineNo = lineNo + newlines;
                                    outputString = outputString + ("<!-- " + content + " -->") + "\n";
                                    continue;
                                }
                                else {
                                    // return helper(commentEnd, lineNo + newlines, outputString + '\n[MUMESLIDE]\n\n')
                                    i = commentEnd;
                                    lineNo = lineNo + newlines;
                                    outputString = outputString + "\n[MUMESLIDE]\n\n";
                                    continue;
                                }
                            }
                        }
                        else {
                            var content = inputString.slice(i + 4, commentEnd - 3).trim();
                            var newlinesMatch = content.match(/\n/g);
                            var newlines = newlinesMatch ? newlinesMatch.length : 0;
                            // return helper(commentEnd, lineNo + newlines, outputString + '\n')
                            i = commentEnd;
                            lineNo = lineNo + newlines;
                            outputString = outputString + ("<!-- " + content + " -->\n");
                            continue;
                        }
                    }
                }
                else if (line.match(/^\s*\[toc\]\s*$/i)) {
                    // [TOC]
                    if (forPreview) {
                        outputString += createAnchor(lineNo); // insert anchor for scroll sync
                    }
                    tocBracketEnabled = true;
                    // return helper(end+1, lineNo+1, outputString + `\n[MUMETOC]\n\n`)
                    i = end + 1;
                    lineNo = lineNo + 1;
                    outputString = outputString + "\n[MUMETOC]\n\n";
                    continue;
                }
                else if (
                /* tslint:disable-next-line:no-conditional-assignment */
                (taskListItemMatch = line.match(/^\s*(?:[*\-+]|\d+\.)\s+(\[[xX\s]\])\s/))) {
                    // task list
                    var checked = taskListItemMatch[1] !== "[ ]";
                    if (!forMarkdownExport) {
                        line = line.replace(taskListItemMatch[1], "<input type=\"checkbox\" class=\"task-list-item-checkbox" + (forPreview ? " sync-line" : "") + "\" " + (forPreview ? "data-line=\"" + lineNo + "\"" : "") + (checked ? " checked" : "") + ">");
                    }
                    // return helper(end+1, lineNo+1, outputString+line+`\n`)
                    i = end + 1;
                    lineNo = lineNo + 1;
                    outputString = outputString + line + "\n";
                    continue;
                }
                else if (
                /* tslint:disable-next-line:no-conditional-assignment */
                (htmlTagMatch = line.match(/^\s*<(?:([a-zA-Z]+)|([a-zA-Z]+)\s+(?:.+?))>/))) {
                    // escape html tag like <pre>
                    var tagName = htmlTagMatch[1] || htmlTagMatch[2];
                    if (!(tagName in selfClosingTag)) {
                        var closeTagName = "</" + tagName + ">";
                        var end2 = inputString.indexOf(closeTagName, i + htmlTagMatch[0].length);
                        if (end2 < 0) {
                            // HTML error. Tag not closed
                            // Do Nothing here. Reason:
                            //     $$ x
                            //     <y>
                            //     $$
                            /*
                              i = inputString.length
                              lineNo = lineNo + 1
                              outputString = outputString + `\n\`\`\`\nHTML error. Tag <${tagName}> not closed. ${closeTagName} is required.\n\`\`\`\n\n`
                              continue
                              */
                        }
                        else {
                            var htmlString = inputString.slice(i, end2 + closeTagName.length);
                            var newlinesMatch = htmlString.match(/\n/g);
                            var newlines = newlinesMatch ? newlinesMatch.length : 0;
                            // return helper(commentEnd, lineNo + newlines, outputString + '\n')
                            i = end2 + closeTagName.length;
                            lineNo = lineNo + newlines;
                            outputString = outputString + htmlString;
                            continue;
                        }
                    }
                }
                // return helper(end+1, lineNo+1, outputString+line+'\n')
                i = end + 1;
                lineNo = lineNo + 1;
                outputString = outputString + line + "\n";
                continue;
            }
            // done
            return {
                outputString: outputString,
                slideConfigs: slideConfigs,
                headings: headings,
                frontMatterString: frontMatterString,
                tocBracketEnabled: tocBracketEnabled,
            };
        }
        var endFrontMatterOffset = 0;
        if (inputString.startsWith("---") &&
            /* tslint:disable-next-line:no-conditional-assignment */
            (endFrontMatterOffset = inputString.indexOf("\n---")) > 0) {
            frontMatterString = inputString.slice(0, endFrontMatterOffset + 4);
            return helper(frontMatterString.length, frontMatterString.match(/\n/g).length);
        }
        else {
            return helper(0, 0);
        }
    }
    exports.transformMarkdown = transformMarkdown;
});
