import { Attributes } from "../addon/attributes/index";
import { Editor } from "codemirror";
export interface WidgetArgs {
    editor?: Editor;
    attributes: Attributes;
    setAttributes?: (attributes: Attributes) => void;
    removeSelf?: () => void;
    replaceSelf?: (inputString: string) => void;
    isPreview?: boolean;
}
export declare type WidgetCreator = (args: WidgetArgs) => HTMLElement;
/**
 *
 * @param name Name of the widget
 * @param creator Creator function
 */
export declare function registerWidgetCreator(name: string, creator: WidgetCreator, forceOverride?: boolean): void;
/**
 *
 * @param name Name of the widget
 */
export declare function getWidgetCreator(name: string): WidgetCreator;
export declare function resetWidgetCreators(): void;
