// 0xGG Team
// Distributed under AGPL3
//
// DESCRIPTION: This widget displays time related information
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
define(["require", "exports", "react", "react-dom", "../component/widget", "../error/error"], function (require, exports, react_1, react_dom_1, widget_1, error_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    react_1 = __importDefault(react_1);
    react_dom_1 = __importDefault(react_dom_1);
    function Timer(props) {
        var attributes = props.attributes;
        return (react_1.default.createElement("div", { style: {
                cursor: "default",
                padding: "4px 12px",
                backgroundColor: attributes["backgroundColor"] || "rgb(250, 145, 1)",
                color: attributes["color"] || "#fff",
                borderRadius: "16px",
                display: "flex",
                justifyContent: "space-between",
                width: "375px",
                maxWidth: "100%",
                boxShadow: "0 1px 3px 1px #aaa"
            } },
            react_1.default.createElement("div", { className: "widget-timer-date" }, "⌚ " + new Date(attributes["date"]).toLocaleString()),
            react_1.default.createElement("div", { className: "widget-timer-duration" }, attributes["duration"] ? "🎬 " + attributes["duration"] : "")));
    }
    exports.TimerWidget = function (args) {
        var el = document.createElement("span");
        if (!args.attributes["date"]) {
            return error_1.ErrorWidget(__assign(__assign({}, args), {
                attributes: {
                    message: "Field 'date' is missing"
                }
            }));
        }
        react_dom_1.default.render(react_1.default.createElement(widget_1.Widget, null,
            react_1.default.createElement(Timer, { attributes: args.attributes, isPreview: args.isPreview })), el);
        return el;
    };
});
